var Intent = null;
var File = null;
var Uri = null;
var main = null;
var cacheCaleState = false;
var os = null;
/**
 * 计算缓存
 */
function caching(callback) {

	mui.plusReady(function() {

		os = plus.os.name;
		if(os == "Android") {
			main = plus.android.runtimeMainActivity();
			Intent = plus.android.importClass("android.content.Intent");
			File = plus.android.importClass("java.io.File");
			Uri = plus.android.importClass("android.net.Uri");
		}
		initCacheSize(function(sign) {
			var objec = callback;
			if(objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object Function]') {
				callback(sign);
			}
		});

	});

}

/**
 * 清除缓存
 */
function scavengingCaching(callback) {
	mui.plusReady(function() {
		if(os == "Android") {
			if(cacheCaleState == true) {
				clearAllCache4Android(function() {

					if(window.localStorage) {
						// 遍历所有存储
						for(item in window.localStorage) {
							if(item != 'userinfo' && item != 'loginData' && item != 'switchData' ) {
								if(window.localStorage.hasOwnProperty(item)) {
									window.localStorage.setItem(item, undefined);
								}
							}
						}
					}

					var objec = callback;
					if(objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object Function]') {
						callback();
					}
				});
			}
		} else if(os == "iOS") {
			clearCache(function() {
				//再次计算缓存大小
				if(window.localStorage) {
					// 遍历所有存储
					for(item in window.localStorage) {
						if(item != 'userinfo' && item != 'loginData'&& item != 'switchData') {
							if(window.localStorage.hasOwnProperty(item)) {
								window.localStorage.setItem(item, undefined);
							}
						}
					}
				}

				var objec = callback;
				if(objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object Function]') {
					callback();
				}
			});
		}
	});
}

function initCacheSize(callback) {
	var formatedSize;
	if(os == "Android") {
		formatedSize = formatSize(calcCache4Android());
		cacheCaleState = true;
		var objec = callback; 
		if(objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object Function]') {
			callback(formatedSize);
		}
	} else if(os == "iOS") {
		calcCache(function(size) {
			cacheCaleState = true;
			formatedSize = formatSize(size);
			var objec = callback;
			if(objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object Function]') {
				callback(formatedSize);
			}
		});
	} else {
		mui.toast("未知的设备类型,无法计算缓存");
		cacheCaleState = false;
	}
}
/**
 * 计算缓存大小  官方提供方法，用于iOS
 */
function calcCache(callback) {
	var finalSize = -1;
	plus.cache.calculate(function(size) {
		var sizeInt = parseInt(size);
		return callback(finalSize);
	});

}

function calcCache4Android() {
	var cacheSize = 0;
	var sdRoot = main.getCacheDir();
	var files = plus.android.invoke(sdRoot, "listFiles");
	cacheSize += getFolderSize(files);
	return cacheSize;
}

function getFolderSize(files) {
	var size = 0;
	var len = files.length;
	for(var i = 0; i < len; i++) {
		// 如果下面还有文件
		if(files[i].isDirectory()) {
			size = size + getFolderSize(files[i]);
		} else if(!files[i].isHidden()) {
			size = size + files[i].length();
		}
	}
	return size;
}

function formatSize(size) {
	var fileSizeString;
	size = parseInt(size);
	if(window.localStorage) {
		// 遍历所有存储
		for(item in window.localStorage) {
			if(true) {
				if(window.localStorage.hasOwnProperty(item)) {
					size += window.localStorage.getItem(item).length;
				}
			}
		}
	}
	if(size == 0) {
		fileSizeString = "0B";
	} else if(size < 1024) {
		fileSizeString = size + "B";
	} else if(size < 1048576) {
		fileSizeString = (size / 1024).toFixed(2) + "KB";
	} else if(size < 1073741824) {
		fileSizeString = (size / 1048576).toFixed(2) + "MB";
	} else {
		fileSizeString = (size / 1073741824).toFixed(2) + "GB";
	}
	return fileSizeString;
}

/**
 * 清除缓存  
 */
function clearCache(callback) {
	plus.storage.clear();
	plus.cache.clear(function() {
		return callback();
	});
}

function clearAllCache4Android(callback) {
	var sdRoot = main.getCacheDir();
	var files = plus.android.invoke(sdRoot, "listFiles");
	deleteDir(files);
	//再次计算缓存大小
	initCacheSize();
	callback();
}

function deleteDir(files) {
	var len = files.length;
	for(var i = 0; i < len; i++) {
		files[i].delete();
	}
}