/**
 * 日期处理
 */
function dateHandle(yearString, dayData) {
	var year = "";
	var month = "";
	var sta_date = new Date(yearString);
	if(sta_date.getFullYear() + "" == 'NaN' || sta_date.getMonth() + "" == 'NaN') {
		sta_date = new Date();
	}
	if(dayData == undefined || dayData == 'undefined' || dayData == '') {
		if(yearString == undefined || yearString == 'undefined' || yearString == '') {
			dayData = sta_date.getDate();
		} else {
			dayData = 1;
		}
	}
	year = sta_date.getFullYear();
	month = sta_date.getMonth() + 1;
	var dayNum = 0; //天数
	var dayArray = []; //当月天数数组  
	//判断当月天数
	if((year % 4 == 0) && (year % 100 != 0 || year % 400 == 0)) {
		var DaysInMonth = new Array(31, 29, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
		dayNum = DaysInMonth[Number(month) - 1];
	} else {
		var DaysInMonth = new Array(31, 28, 31, 30, 31, 30, 31, 31, 30, 31, 30, 31);
		dayNum = DaysInMonth[Number(month) - 1];
	}
	if(dayData > dayNum || dayData < 1) {
		dayData = 1;
	}
	//判断当月天数
	//判断第一天是星期几

	for(var i = 0; i < onDay(Number(year), Number(month), 1); i++) {
		dayArray.push({});
	}
	//判断第一天是星期几
	//添加天数数组
	var map = {};
	var onDayString;
	var myDate = new Date();
	for(var i = 1; i <= dayNum; i++) {
		onDayString = onDay(Number(year), Number(month), i); //计算是星期几
		map = {};
		map.day = i; //日
		map.lunar = getLunarCalendar(Number(year), Number(month), i).dayString; //农历
		map.isSelection = dayData == i ? true : false; //是否是当前选中
		map.isDay = false; //是否是当天
		map.isValuable = false; //是否有值
		map.isSaturday = onDayString == 0 || onDayString == 6 ? true : false; //是否是周六或者周日
		if((Number(myDate.getFullYear()) == Number(year)) && (Number(myDate.getMonth() + 1) == Number(month)) && (Number(myDate.getDate()) == Number(i))) {
			map.isDay = true; //是否是当天
		}
		dayArray.push(map);
	}
	//添加天数数组

	/**
	 * 获取当前是星期几
	 * @param {Object} year
	 * @param {Object} month
	 * @param {Object} day
	 */
	function onDay(year, month, day) {
		var myDate = new Date();
		myDate.setFullYear(Number(year), Number(month) - 1, day);
		var week = myDate.getDay();
		return week;

	}

	return {
		year: year,
		month: month,
		dayData: dayData,
		array: dayArray
	};

}

/**
 * 获取农历日期
 * @param {Object} yy
 * @param {Object} mm
 * @param {Object} dd
 */
function getLunarCalendar(yy, mm, dd) {
	var CalendarData = new Array(100);
	var madd = new Array(12);
	var tgString = "甲乙丙丁戊己庚辛壬癸";
	var dzString = "子丑寅卯辰巳午未申酉戌亥";
	var numString = "一二三四五六七八九十";
	var monString = "正二三四五六七八九十冬腊";
	var weekString = "日一二三四五六";
	var sx = "鼠牛虎兔龙蛇马羊猴鸡狗猪";
	var cYear, cMonth, cDay, TheDate;
	CalendarData = new Array(0xA4B, 0x5164B, 0x6A5, 0x6D4, 0x415B5, 0x2B6, 0x957, 0x2092F, 0x497, 0x60C96, 0xD4A, 0xEA5, 0x50DA9, 0x5AD, 0x2B6, 0x3126E, 0x92E, 0x7192D, 0xC95, 0xD4A, 0x61B4A, 0xB55, 0x56A, 0x4155B, 0x25D, 0x92D, 0x2192B, 0xA95, 0x71695, 0x6CA, 0xB55, 0x50AB5, 0x4DA, 0xA5B, 0x30A57, 0x52B, 0x8152A, 0xE95, 0x6AA, 0x615AA, 0xAB5, 0x4B6, 0x414AE, 0xA57, 0x526, 0x31D26, 0xD95, 0x70B55, 0x56A, 0x96D, 0x5095D, 0x4AD, 0xA4D, 0x41A4D, 0xD25, 0x81AA5, 0xB54, 0xB6A, 0x612DA, 0x95B, 0x49B, 0x41497, 0xA4B, 0xA164B, 0x6A5, 0x6D4, 0x615B4, 0xAB6, 0x957, 0x5092F, 0x497, 0x64B, 0x30D4A, 0xEA5, 0x80D65, 0x5AC, 0xAB6, 0x5126D, 0x92E, 0xC96, 0x41A95, 0xD4A, 0xDA5, 0x20B55, 0x56A, 0x7155B, 0x25D, 0x92D, 0x5192B, 0xA95, 0xB4A, 0x416AA, 0xAD5, 0x90AB5, 0x4BA, 0xA5B, 0x60A57, 0x52B, 0xA93, 0x40E95);
	madd[0] = 0;
	madd[1] = 31;
	madd[2] = 59;
	madd[3] = 90;
	madd[4] = 120;
	madd[5] = 151;
	madd[6] = 181;
	madd[7] = 212;
	madd[8] = 243;
	madd[9] = 273;
	madd[10] = 304;
	madd[11] = 334;

	function GetBit(m, n) {
		return(m >> n) & 1;
	}

	function e2c() {
		TheDate = (arguments.length != 3) ? new Date() : new Date(arguments[0], arguments[1], arguments[2]);
		var total, m, n, k;
		var isEnd = false;
		var tmp = TheDate.getYear();
		if(tmp < 1900) {
			tmp += 1900;
		}
		total = (tmp - 1921) * 365 + Math.floor((tmp - 1921) / 4) + madd[TheDate.getMonth()] + TheDate.getDate() - 38;

		if(TheDate.getYear() % 4 == 0 && TheDate.getMonth() > 1) {
			total++;
		}
		for(m = 0;; m++) {
			k = (CalendarData[m] < 0xfff) ? 11 : 12;
			for(n = k; n >= 0; n--) {
				if(total <= 29 + GetBit(CalendarData[m], n)) {
					isEnd = true;
					break;
				}
				total = total - 29 - GetBit(CalendarData[m], n);
			}
			if(isEnd) break;
		}
		cYear = 1921 + m;
		cMonth = k - n + 1;
		cDay = total;
		if(k == 12) {
			if(cMonth == Math.floor(CalendarData[m] / 0x10000) + 1) {
				cMonth = 1 - cMonth;
			}
			if(cMonth > Math.floor(CalendarData[m] / 0x10000) + 1) {
				cMonth--;
			}
		}
	}

	function GetcDateString() {
		var tmp = "";
		/*tmp += tgString.charAt((cYear - 4) % 10);
		tmp += dzString.charAt((cYear - 4) % 12);
		tmp += "(";
		tmp += sx.charAt((cYear - 4) % 12);
		tmp += ")年 ";*/
		if(cMonth < 1) {
			//tmp += "(闰)";
			tmp += monString.charAt(-cMonth - 1);
		} else {
			tmp += monString.charAt(cMonth - 1);
		}
		tmp += "月";
		var tmp1 = (cDay < 11) ? "初" : ((cDay < 20) ? "十" : ((cDay < 30) ? "廿" : "三十"));
		if(cDay % 10 != 0 || cDay == 10) {
			tmp1 += numString.charAt((cDay - 1) % 10);
		}
		return {
			month: tmp, //农历月份
			day: tmp1, //农历日
			dayString: tmp1 == '初一' ? tmp : tmp1, //初一显示月份
		};
	}

	function GetLunarDay(solarYear, solarMonth, solarDay) {
		//solarYear = solarYear<1900?(1900+solarYear):solarYear;
		if(solarYear < 1921 || solarYear > 2025) {
			return "";
		} else {
			solarMonth = (parseInt(solarMonth) > 0) ? (solarMonth - 1) : 11;
			e2c(solarYear, solarMonth, solarDay);
			return GetcDateString();
		}
	}

	return GetLunarDay(yy, mm, dd);
}

/**
 * 日期选择
 * @param {Object} years 初始年
 * @param {Object} month 初始月
 * @param {Object} day 初始 日
 * @param {Object} callback 初始（years，month，day）
 */
function pickDate(years, month, day, callback) {
	function plusReady() {
		var dDate = new Date();
		dDate.setFullYear(Number(years), Number(month) - 1, Number(day));
		var minDate = new Date();
		minDate.setFullYear(2007, 0, 1);
		var maxDate = new Date();
		maxDate.setFullYear(2030, 11, 31);
		plus.nativeUI.pickDate(function(e) {
			var d = e.date;
			years = d.getFullYear();
			month = d.getMonth() + 1;
			day = d.getDate();
			callback(years, month, day);
		}, function(e) {
			callback(years, month, day);
		}, {
			date: dDate,
			minDate: minDate,
			maxDate: maxDate
		});
	}
	if(window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}

}
/**
 * 时间选择
 * @param {Object} dtime 时间格式字符串
 * @param {Object} callback
 */
function pickTime(dtime, callback) {
	function plusReady() {

		var dTime = new Date();
		var dtimeArray = dtime != undefined && dtime != 'undefined' && dtime != '' ? dtime.split(':') : [];
		if(dtimeArray.length == 2) {
			dTime.setHours(Number(dtimeArray[0]), Number(dtimeArray[1]));
		}
		plus.nativeUI.pickTime(function(e) {
			var d = e.date;
			var hours = d.getHours() >= 10 ? d.getHours() : "0" + d.getHours();
			var inutes = d.getMinutes() >= 10 ? d.getMinutes() : "0" + d.getMinutes();
			callback(hours + ":" + inutes);
		}, function(e) {
			callback(dtime);
		}, {
			is24Hour: true,
			time: dTime
		});
	}
	if(window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}

}

/**
 * 底部选择框
 * @param {Object} dtime 时间格式字符串
 * @param {Object} callback
 */
function actionSheet(array, callback) {
/*{
				title: "1"
			}*/
	// H5 plus事件处理
	function plusReady() {
		// 弹出系统选择按钮框
		plus.nativeUI.actionSheet({
			title: "提醒方式",
			cancel: "取消",
			buttons: array
		}, function(e) {
			if(e.index != 0){
			   callback(array[e.index - 1]);
			}
		});
	}
	if(window.plus) {
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}
}

/**
 * 计算两时间的记时
 * @param {Object} starTime 开始时间
 * @param {Object} endTime 结束时间
 */
function calculationUseTime(startTime,endTime){
	try{
        var  usedTime = endTime - startTime; // 相差的毫秒数
        var  usedTime1 = endTime - startTime; // 相差的毫秒数
        usedTime = usedTime / 1000;//秒 
        var hours = Math.floor(usedTime / 3600); // 计算剩余的小时数
        var minutes = Math.floor((usedTime - hours * 3600) / 60); // 计算剩余的分钟数
        var leavel2 =  Math.floor(usedTime - (hours * 3600 + minutes * 60)); // 计算剩余的秒数
        
        if(hours < 10){
        	hours = "0"+hours;
        }
        if(minutes < 10){
        	minutes = "0"+minutes;
        }
        if(leavel2 < 10){
        	leavel2 = "0"+leavel2;
        }
        return { 
        	data:hours+":"+minutes+":"+leavel2,
        	minutes:Math.floor(usedTime),
        	usedTime:usedTime1
        };
	}catch(err){
	}
}


/**
* 计算考试时间
 * @param {Object} totalUseTime 总用时 例如 60分钟
 * @param {Object} startTime 开始考试时间
 * @param {Object} endTime 结束考试时间  
 * @param {Object} xianzTiem 现在考试总用时
 * @param {Object} actualStartTime 实际开始时间
 */ 
function calculationExaminationTime(totalUseTime,startTime,endTime,actualStartTime){
	
	 totalUseTime = isEmptyType(totalUseTime, '4').value;
	 startTime = isEmptyType(startTime, '4').value;
	 endTime = isEmptyType(endTime, '4').value;
	 if(totalUseTime == '' && startTime == '' && endTime == ''){ 
	 	 return 600 * 60; 
	 }
     if(tiemToDate(startTime)){
	 	 var startTimeDate = new Date(startTime);
	 	 if((startTimeDate - actualStartTime) > 0){    
	 	 	 return 0;
	 	 }
	 }
	 
	  if(tiemToDate(endTime)){
	 	 var endTimeDate = new Date(endTime);
	 	 if((endTimeDate - actualStartTime) < 0){
	 	 	 return 0;
	 	 }
	 }
	  
	  if(totalUseTime == '' || (Number(totalUseTime)) == 'NaN'){
	  	 totalUseTime = 600; 
	  }
	 
	  
	 totalUseTime = Number(totalUseTime);
	 var toy = actualStartTime.getTime() ;//总毫秒数
	 var tou = 0;
	
	 if(tiemToDate(endTime)){ 
	 	 tou = new Date(endTime).getTime();  
	 }else {
	 	 tou = actualStartTime.getTime() + (1000 * 36000);           
	 }
	 
	 
	
	 if(tou > toy){
	 	 var hTiem = Math.round((tou - toy) / (1000 * 60)); 
		 if(hTiem > totalUseTime){  
	 	 	 return totalUseTime * 60; 
	 	 }else {
	 	 	return hTiem * 60;
	 	 }
	 	
	 } 
	
	 return 0;
} 

/**
 * 判断是否转换的字符串是否成功
 * @param {Object} string
 */
function tiemToDate(string){
	var endTimeDate = new Date(string);  
	var g = endTimeDate.getFullYear() + "";
	if(g != 'NaN'){
		return true;
	}else{
		return false;
	}
}

/**
 * 获取完整时间串
 * @param {Object} string
 */
function getTiemToDate(){
	var dTime = new Date();
	var Year = dTime.getFullYear();
	var month = (dTime.getMonth()+1)< 10 ? "0" + (dTime.getMonth()+1) :(dTime.getMonth()+1);
	var day = dTime.getDate()< 10 ? "0" + dTime.getDate():dTime.getDate();
	var Hours = dTime.getHours()< 10 ? "0" + dTime.getHours():dTime.getHours();
	var Minutes = dTime.getMinutes()< 10 ? "0" + dTime.getMinutes():dTime.getMinutes();
    var Seconds = dTime.getSeconds()< 10 ? "0" + dTime.getSeconds():dTime.getSeconds();

	return  Year + "-"+month+"-"+day+" "+Hours+":"+Minutes+":"+Seconds;
}

/**
 * 计算倒计时
 * @param {Object} starTime 已用时间（秒）
 * @param {Object} whole 总时间（秒）
 */
function countDownTime(already,whole){
	already = isEmptyType(already,'5').value;
	whole = isEmptyType(whole,'5').value;
	
	if(whole >= already){
		var total = whole - already;
		var time = parseInt(total / (60 * 60));
		var branch = parseInt((total - time * 60 * 60) / (60));
		var second = total - time * 60 * 60 - branch * 60;
		if(time < 10){
			time = "0"+time;
		}
		if(branch < 10){
			branch = "0"+branch;
		}
		if(second < 10){
			second = "0"+second;
		}
		return time + ":" + branch+ ":" + second;
	}else{
		return "00:00:00";
	}
}