/**
 * 创建人：李健功
 * 功能：h+ api的一些方法
 */

/**
 * 关闭上几个页面
 * num：关闭的页面数
 */
function closePageNum(num, callback) {
	var objec = Number(num);
	var objecString = "" + objec;
	//判断是否为数字
	if (objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object Number]' &&
		objecString != NaN && objecString != 'NaN') {
		num = objec; //最终的值
	} else {
		num = 0; //最终的值
	}

	function plusReady() {
		// 获取所有Webview窗口
		var wvs = plus.webview.all();
		var index = 0;
		for (var i = wvs.length - 2; i > 0 && index < num; i--) {
			index++;
			plus.webview.close(wvs[i].id, "none");
		}
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 除了现在界面为关闭所有窗口
 */
function closeAll(id) {
	function plusReady() {
		// 获取所有Webview窗口
		var ws = plus.webview.getWebviewById(id);
		var wvs = plus.webview.all();
		for (var i = 0; i < wvs.length - 1; i++) {
			if (ws != undefined && ws != 'undefined') {
				if (id != wvs[i].id) {
					plus.webview.close(wvs[i].id, "none");
				}
			} else {
				plus.webview.close(wvs[i].id, "none");
			}

		}
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 关闭除了特定页面的所有页面
 */
function closeGivenAll(url) {
	function plusReady() {
		// 获取所有Webview窗口
		var wvs = plus.webview.all();
		for (var i = 0; i < wvs.length; i++) {
			if (wvs[i].getURL().indexOf(url) == -1) {
				plus.webview.close(wvs[i].id, "none");
			}
		}
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 关闭特定id 的所有页面
 */
function closeSurplusPage(id) {
	function plusReady() {
		// 获取所有Webview窗口

		var wvs = plus.webview.all();
		if (id == undefined || id == 'undefined' || id == '') {
			id = wvs[wvs.length - 1].id;
		}
		for (var i = 0; i < wvs.length - 1; i++) {
			if (id == wvs[i].id) {
				plus.webview.close(wvs[i].id, "none");
			}
		}
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 关闭特定id 的所有页面
 */
function closeSurplusPage1(id) {
	function plusReady() {
		// 获取所有Webview窗口

		var wvs = plus.webview.all();
		for (var i = 0; i < wvs.length - 1; i++) {
			if (id == wvs[i].id) {
				plus.webview.close(wvs[i].id, "none");
			}
		}
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 打开三方url
 */
function openURLX(url, errorCB) {
	function plusReady() {

		plus.runtime.openURL(url, function() {
			if (errorCB != undefined && errorCB != 'undefined') {
				errorCB("打开失败！");
			}
		})
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 创建新窗口
 * @param {Object} url 窗口路径
 * @param {Object} id 窗口id
 */
function createWebview(url, id) {

	function plusReady() {
		setTimeout(function() {
			var ws = plus.webview.getWebviewById(id);
			if (ws == undefined || ws == 'undefined') {
				plus.webview.create(url, id);
			}
		}, 5)

	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}

}

/**
 * 创建多个新窗口
 * @param {Object} objec [url:"2222",id:""]
 */
function createMultipleWebview(objec) {

	setTimeout(function() {
		if (objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object Array]' &&
			objec.length != 0) {
			var j = 0;
			for (var i = 0; i < objec.length; i++) {
				createWebview(objec[i].url, objec[i].id);
			}
			/*mui.init({
		    preloadPages:objec
		  });*/

			return true;
		} else {

			return false;
		}
	}, 5)

}

/**
 * 分享信息（使用组件分享）
 * @param {Object} content 分享内容
 * @param {Object} href 分享网址
 */
function plusShare(content, href, callback) {

	function plusReady() {
		plus.share.sendWithSystem({
			content: content + href,
			href: href
		}, function() {
			if (isEmptyType(callback, '3')) {
				callback(true);
			}
		}, function(e) {
			if (isEmptyType(callback, '3')) {
				callback(false);
			}
		});
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}

}

/**
 * 分享信息
 * @param {Object} id 分享id ：weixin/微信  qq/QQ  sinaweibo/新浪微博
 * @param {Object} content 分享内容
 * @param {Object} href 分享网址
 * @param {Object} imgsUrl 缩列图
 */
function share(id,title,content, href,imgsUrl, callback,isType) {
    if(isEmptyType(content + "",'4').value == '' && isEmptyType(href + "",'4').value == ''&& isEmptyType(title + "",'4').value == ''){
		 if(isEmptyType(callback,'3').isCorrect){
			 callback(false,'分享内容为空！')
		 }
	}
	function plusReady() {
		// 扩展API加载完毕，现在可以正常调用扩展API
		plus.share.getServices(function(s){
			var isId = '该分享主体不存在，请联系管理人员！';
			var shareObj = null; 
			//console.log('s = ' + JSON.stringify(s))
			for(var i= 0;i < s.length;i++){
				 if(s[i].id == id){
					 shareObj = s[i];
					 if(!s[i].authenticated){
						 isId = '授权认证失败！';
					 }else if(!s[i].authenticated){
						 isId = '请下载'+s[i].description + "客户端！";
					 }else{
						  isId = '可以分享！';
					 }
					
					 break;
				 }
			} 
			if(isId == '可以分享！'){ 
				var msgObj = {};
				msgObj.type = "web";
				msgObj.title =  isEmptyType(title + "",'4').value;
				msgObj.content = isEmptyType(title + "",'4').value;
				if(msgObj.title.length >= 20){
					msgObj.title = msgObj.title.substring(1, 20);  
				}
				if(msgObj.content.length >= 20){
					msgObj.content = msgObj.content.substring(1, 20); 
				}
				
				msgObj.thumbs =isEmptyType(imgsUrl + "",'4').value ; 
				msgObj.thumbs = msgObj.thumbs != '' ? msgObj.thumbs : "";
				msgObj.href =isEmptyType(href + "",'4').value;
				if(isType == '2' || isType == 2){
					msgObj.extra={scene:"WXSceneTimeline"} // 'WXSceneSession'分享给好友，'WXSceneTimeline'分享到朋友圈
				}else{
					msgObj.extra={scene:"WXSceneSession"} // 'WXSceneSession'分享给好友，'WXSceneTimeline'分享到朋友圈
					
				}
				shareObj.send(msgObj, function(){
					callback(true,"分享成功！");
				}, function(error){
					callback(false,"分享失败："+error.message);
				})
				
			}else{
				if(isEmptyType(callback,'3').isCorrect){
					callback(false,"分享失败，请联系开发人员配置相应信息！");
				}
			}
			
		}, function(e){
			if(isEmptyType(callback,'3').isCorrect){
						 callback(false,"获取分享服务列表失败："+e.message)
			}
		});
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}

}


/**
 * 关闭多个窗口的界面
 * @param {Object} objec [url:"2222",id:""]
 */
function closeMultiplePage(objec) {

	if (objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object Array]' && objec.length !=
		0) {

		for (var i = 0; i < objec.length; i++) {
			closePage(objec[i].id);
		}
		return true;
	} else {
		return false;
	}

}

/**
 * 显示窗口
 * @param {Object} url 窗口的路径
 * @param {Object} id 窗口的eid
 * @param {Object} aniShow 打开的动画
 * @param {Object} duration 打开动画的时间
 * @param {Object} refresh 同时新窗口刷新的函数
 */
function showWebview(url, id, aniShow, duration, refresh) {
	if (aniShow == undefined || aniShow == 'undefined') {
		aniShow = 'none';
	}

	if (duration == undefined || duration == 'undefined') {
		duration = 0;
	}

	function plusReady() {
		localStorage.webviewToolId = plus.webview.currentWebview().id;
		var ws = plus.webview.getWebviewById(id);
		if (ws != undefined && ws != 'undefined') {
			if (plus.webview.getLaunchWebview() != undefined && plus.webview.getLaunchWebview() != 'undefined' && plus.webview.getLaunchWebview()
				.id != id && ws.getURL().indexOf(id) == -1) {
				ws.loadURL(url)
			}

			if (refresh != undefined && refresh != 'undefined') {

				plus.webview.getWebviewById(id).evalJS(refresh);
			}
			plus.webview.show(id, aniShow, duration);

			/* var all = plus.webview.all();
			 for(var i = 0;i<all.length;i++){
				console.log(' i = '+i+' ,id= ' + all[i].id + "  ,url"+all[i].getURL() + " isVisible = "+all[i].isVisible())
			 }*/

		} else {
			var df = plus.webview.create(url, id);
			if (refresh != undefined && refresh != 'undefined') {
				df.evalJS(refresh);
			}
			df.show();

		}
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}

}

/**
 * 关闭窗口的界面
 * @param {Object} id 要关闭的界面 id
 */
function closePage(id) {

	function plusReady() {
		var wv = plus.webview.getWebviewById(id);
		if (wv == undefined || wv == 'undefined') {
			id = plus.webview.currentWebview().id;
		}
		plus.webview.close(id);

	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 隐藏窗口
 * @param {Object} id 隐藏窗口的id
 * @param {Object} aniHide 隐藏的的动画
 * @param {Object} duration 隐藏的动画时间
 */
function hideWebview(id, aniHide, duration) {
	if (aniHide == undefined || aniHide == 'undefined') {
		aniHide = 'none';
	}

	if (duration == undefined || duration == 'undefined') {
		duration = 0;
	}

	function plusReady() {
		if (id != undefined && id != 'undefined') {
			plus.webview.hide(id, aniHide, duration);

		} else {
			plus.webview.hide(plus.webview.currentWebview().id, aniHide, duration);

		}
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 刷新窗口的界面
 * @param {Object} id 要刷新的界面 id
 */
function refreshPage(id, refresh) {
	function plusReady() {
		var wv = plus.webview.getWebviewById(id);
		if (wv) {
			if (refresh != undefined && refresh != 'undefined') {
				plus.webview.getWebviewById(id).evalJS(refresh);
			}

		} else {

			if (refresh != undefined && refresh != 'undefined') {
				var wvs = plus.webview.all();
				if (wvs.length != 1) {
					plus.webview.getWebviewById(wvs[wvs.length - 2].id).evalJS(refresh);
				}
			}
		}

	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 设置状态栏颜色
 * @param {Object} strColor
 */
function setStatusBarBackground(strColor) {
	function plusReady() {
		plus.navigator.setStatusBarBackground(strColor);
		//plus.navigator.setFullscreen(true);
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * mui 上下拉刷新
 * @param {Object} contentId 刷新主面板
 * @param {Object} isUp 是否需要上拉刷新
 * @param {Object} isAuto 初始化自动刷新的标志，isAuto = "down" 下拉，isAuto = "up" 上拉
 * @param {Object} num 一次刷新的 总数
 * @param {Object} refreshCallback 回调处理函数 （参数如下）
 * 1.page ：当前回调的页数
 * 2.num ：总数
 * 3.direction ：返回是 direction = "down"下拉，direction = "up"上拉
 * 4.callback(shu) 关闭的回调 只有一个参数 shu<num 还有数据，shu>=num 暂无数据
 */
function muiRefresh_mui(contentId, num, isUp, isAuto, refreshCallback) {

	function plusReady() {
		var page = 0; //页数
		var downAuto = false; //下拉自动刷新
		var upAuto = false; //上拉自动刷新
		var upRefresh = {}; //下拉刷新
		if (isAuto != undefined && isAuto != 'undefined' && (isAuto == "down" || isAuto == "up")) {
			if (isAuto == 'down') {
				downAuto = true;
			} else {
				upAuto = true;
			}

		}

		if (num == undefined || num == 'undefined' || typeof num != 'number' || num % 1 != 0 || num < 1) {
			num = 10;
		}

		//需要上拉刷新
		if (isUp != undefined && isUp != 'undefined' && isUp == true) {
			mui.init({
				pullRefresh: {
					container: contentId,
					up: {
						contentrefresh: '正在加载...',
						auto: upAuto,
						callback: function() {
							stopPullToRefresh();
							page++;
							refreshCallback(page, num, "up", function(sign1) {
								startPullToRefresh1();
								if (sign1 != undefined && sign1 != 'undefined' && (typeof sign1 === 'number' && sign1 % 1 === 0) && sign1 >=
									num) {
									mui(contentId).pullRefresh().endPullupToRefresh(); //refresh completed
								} else {
									mui(contentId).pullRefresh().endPullupToRefresh(true); //refresh completed
								}
							});
						}
					}
				}
			});

		}

		//需要下拉刷新处理

		var ws = plus.webview.currentWebview();
		ws.setPullToRefresh({
				support: true,
				style: 'circle', //必选，下拉刷新样式，目前支持原生5+ ‘circle’ 样式
				color: '#DC3535', //可选，默认“#2BD009” 下拉刷新控件颜色
				height: '50px', //可选,默认50px.下拉刷新控件的高度,
				range: '100px', //可选 默认100px,控件可下拉拖拽的范围
				offset: '50px', //可选 默认0px,下拉刷新控件的起始位置
			},
			onRefresh);

		if (downAuto) {
			setTimeout(function() {
				ws.beginPullToRefresh();
			}, 10);
		}

		// 刷新页面
		function onRefresh() {
			page = 1;
			if (isUp != undefined && isUp != 'undefined' && mui(contentId).pullRefresh() != undefined && mui(contentId).pullRefresh() !=
				'undefined' && mui(contentId).pullRefresh()) {
				mui(contentId).pullRefresh().endPullupToRefresh(true); //refresh completed
			}
			refreshCallback(page, num, "down", function(sign1) {
				if (sign1 != undefined && sign1 != 'undefined' && (typeof sign1 === 'number' && sign1 % 1 === 0) && sign1 >= num) {
					ws.endPullToRefresh();
					if (isUp != undefined && isUp != 'undefined' && mui(contentId).pullRefresh() != undefined && mui(contentId).pullRefresh() !=
						'undefined' && mui(contentId).pullRefresh()) {
						mui(contentId).pullRefresh().endPullupToRefresh(); //refresh completed
						mui(contentId).pullRefresh().enablePullupToRefresh(); //重新启用上拉刷新
					}

				} else {
					ws.endPullToRefresh();
					if (isUp != undefined && isUp != 'undefined' && mui(contentId).pullRefresh() != undefined && mui(contentId).pullRefresh() !=
						'undefined' && mui(contentId).pullRefresh()) {
						mui(contentId).pullRefresh().endPullupToRefresh(); //refresh completed
						mui(contentId).pullRefresh().enablePullupToRefresh(); //重新启用上拉刷新
						mui(contentId).pullRefresh().endPullupToRefresh(true); //refresh completed
					}
				}
			});

		}
		//需要下拉刷新处理
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}

}

/**
 * mui 上下拉刷新
 * @param {Object} contentId 刷新主面板
 * @param {Object} isUp 是否需要上拉刷新
 * @param {Object} isAuto 初始化自动刷新的标志，isAuto = "down" 下拉，isAuto = "up" 上拉
 * @param {Object} num 一次刷新的 总数
 * @param {Object} refreshCallback 回调处理函数 （参数如下）
 * 1.page ：当前回调的页数
 * 2.num ：总数
 * 3.direction ：返回是 direction = "down"下拉，direction = "up"上拉
 * 4.callback(shu) 关闭的回调 只有一个参数 shu<num 还有数据，shu>=num 暂无数据
 */
function muiRefresh(contentId, num, isUp, isAuto, refreshCallback) {
	var page = 0; //页数
	var downAuto = false; //下拉自动刷新
	var upAuto = false; //上拉自动刷新
	var upRefresh = {}; //下拉刷新
	if (isAuto != undefined && isAuto != 'undefined' && (isAuto == "down" || isAuto == "up")) {
		if (isAuto == 'down') {
			downAuto = true;
		} else {
			upAuto = true;
		}

	}

	if (num == undefined || num == 'undefined' || typeof num != 'number' || num % 1 != 0 || num < 1) {
		num = 10;
	}

	//需要下拉刷新
	if (isUp != undefined && isUp != 'undefined' && isUp == true) {
		upRefresh = {
			contentrefresh: '正在加载...',
			auto: upAuto,
			callback: function() {
				stopPullToRefresh();
				page++;
				refreshCallback(page, num, "up", function(sign1) {
					startPullToRefresh1();
					if (sign1 != undefined && sign1 != 'undefined' && (typeof sign1 === 'number' && sign1 % 1 === 0) && sign1 >=
						num) {
						mui(contentId).pullRefresh().endPullupToRefresh(); //refresh completed
					} else {
						mui(contentId).pullRefresh().endPullupToRefresh(true); //refresh completed
					}
				});
			}
		}
	}

	if (refreshCallback && $.type(refreshCallback) === "function") {
		mui.init({
			pullRefresh: {
				container: contentId,
				down: {
					style: 'circle', //必选，下拉刷新样式，目前支持原生5+ ‘circle’ 样式
					color: '#DC3535', //可选，默认“#2BD009” 下拉刷新控件颜色
					height: '50px', //可选,默认50px.下拉刷新控件的高度,
					range: '50px', //可选 默认100px,控件可下拉拖拽的范围
					offset: '50px', //可选 默认0px,下拉刷新控件的起始位置
					auto: downAuto,
					callback: function() {
						page = 1;
						mui(contentId).pullRefresh().endPullupToRefresh(true); //refresh completed
						refreshCallback(page, num, "down", function(sign1) {
							if (sign1 != undefined && sign1 != 'undefined' && (typeof sign1 === 'number' && sign1 % 1 === 0) && sign1 >=
								num) {
								mui(contentId).pullRefresh().endPulldownToRefresh(); //refresh completed

								if (isUp) {
									mui(contentId).pullRefresh().endPullupToRefresh(); //refresh completed
									mui(contentId).pullRefresh().enablePullupToRefresh(); //重新启用上拉刷新
								}

							} else {
								mui(contentId).pullRefresh().endPulldownToRefresh(true); //refresh completed
								if (isUp) {
									mui(contentId).pullRefresh().endPullupToRefresh(); //refresh completed
									mui(contentId).pullRefresh().enablePullupToRefresh(); //重新启用上拉刷新
									mui(contentId).pullRefresh().endPullupToRefresh(true); //refresh completed
								}
							}
						});
					}
				},
				up: upRefresh
			}
		});
	}
}

/**
 * 仿停止下拉刷新
 */
function stopPullToRefresh() {
	// 扩展API加载完毕，现在可以正常调用扩展API 
	function plusReady() {
		var ws = plus.webview.currentWebview();
		ws.setPullToRefresh({
			support: false,
			style: 'circle',
			offset: '45px'
		});
	}
	// 判断扩展API是否准备，否则监听'plusready'事件
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 开始下拉下拉刷新
 */
function startPullToRefresh1() {
	// 扩展API加载完毕，现在可以正常调用扩展API 
	function plusReady() {
		var ws = plus.webview.currentWebview();
		ws.setPullToRefresh({
			support: true,
			style: 'circle', //必选，下拉刷新样式，目前支持原生5+ ‘circle’ 样式
			color: '#DC3535', //可选，默认“#2BD009” 下拉刷新控件颜色
			height: '50px', //可选,默认50px.下拉刷新控件的高度,
			range: '100px', //可选 默认100px,控件可下拉拖拽的范围
			offset: '50px', //可选 默认0px,下拉刷新控件的起始位置
		});

	}
	// 判断扩展API是否准备，否则监听'plusready'事件
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 重置下拉刷新
 */
function resetPullToRefresh() {
	var ws = plus.webview.currentWebview();
	ws.setPullToRefresh({
		support: true,
		style: 'circle', //必选，下拉刷新样式，目前支持原生5+ ‘circle’ 样式
		color: '#DC3535', //可选，默认“#2BD009” 下拉刷新控件颜色
		height: '50px', //可选,默认50px.下拉刷新控件的高度,
		range: '100px', //可选 默认100px,控件可下拉拖拽的范围
		offset: '50px', //可选 默认0px,下拉刷新控件的起始位置
	});

	if (downAuto) {
		setTimeout(function() {
			ws.beginPullToRefresh();
		}, 10);
	}
}

/**
 * 重置下拉刷新
 */
function resetPullToRefresh_mui(contentId) {
	if (mui(contentId).pullRefresh() != undefined && mui(contentId).pullRefresh() != 'undefined') {
		mui(contentId).pullRefresh().pulldownLoading();
	}
}

/**
 * 重置上拉拉刷新(主动触发上拉加载)
 */
function resetPullUpRefresh(contentId) {
	if (mui(contentId).pullRefresh() != undefined && mui(contentId).pullRefresh() != 'undefined') {
		mui(contentId).pullRefresh().endPullupToRefresh(); //refresh completed
		mui(contentId).pullRefresh().enablePullupToRefresh(); //重新启用上拉刷新
		mui(contentId).pullRefresh().pullupLoading();
	}
}

/**
 * 关闭页面滚动条
 */
function stopScrollBar() {
	//去掉滚动条
	function plusReady() {
		plus.webview.currentWebview().setStyle({ //隐藏滚动条
			scrollIndicator: 'none'
		});
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 打开新的页面 
 * @param {Object} url 打开的网址
 * @param {Object} id  打开页面的id
 * @param {Object} Refresh 是否为新的窗口，新的为 true
 * @param {Object} 打开动画 aniShow  'slide-in-right'
 */
function openPage(url, id, Refresh, aniShow) {

	if (!isEmptyType(url, '4').remarks) {
		return;
	}
	id = isEmptyType(id, '4').remarks ? id : url;
	Refresh = isEmptyType(Refresh, '6').isCorrect ? Refresh : true;
	aniShow = isEmptyType(aniShow, '4').remarks ? aniShow : 'none';

	mui.openWindow({
		url: url,
		id: id,
		styles: {
			top: 0,
			bottom: 0,
			height: '100%',
		},
		createNew: ismobile() == 'isiOS' ? true : Refresh,//Refresh
		show: {
			autoShow: true,
			aniShow: aniShow, //页面显示动画，默认为”slide-in-right“；
			duration: 300
		},
		waiting: {
			autoShow: false
		}
	});
}

/**
 * 窗口刷新数据
 * @param {Object} id 窗口id
 * @param {Object} name 刷新的函数名
 */
function refreshPageData(id, name) {

	function plusReady() {

		var page = plus.webview.getWebviewById(id);
		if (page) {
			page.evalJS(name);
			console.log("进入刷新");
		} else {
			console.log("不存在窗体");
		}
	}

	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}

}

/**
 * 提交等待框
 * @param {Object} id 窗口id
 * @param {Object} name 刷新的函数名
 */
function showWaiting(objec) {

	function plusReady() {

		if ((objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object String]')) {
			objec = ''; //最终的值
		}
		var nwaiting = plus.nativeUI.showWaiting(objec);
	}

	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}

}

/**
 * 分享
 * @param {Object} id 要刷新的界面 id
 */
function shareSystem(content, href, callback) {
	function plusReady() {
		plus.share.sendWithSystem({
			content: content,
			href: href
		}, function() {
			if (callback != undefined && callback != 'undefined' && Object.prototype.toString.call(callback) ==
				'[object Function]') {
				callback(true);
			}
		}, function(e) {
			if (callback != undefined && callback != 'undefined' && Object.prototype.toString.call(callback) ==
				'[object Function]') {
				callback(false);
			}
		});

	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 打开三方
 * @param {Object} copy_content
 */
function openURL(url, callback) {
	function plusReady() {
		plus.runtime.openURL(url); //调用浏览器打开网址 
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 复制内容
 * @param {Object} copy_content
 */
function copyShareUrl(copy_content, callback) {
	function plusReady() {
		//复制链接到剪切板
		//判断是安卓还是ios
		if (mui.os.ios) {
			//ios
			var UIPasteboard = plus.ios.importClass("UIPasteboard");
			var generalPasteboard = UIPasteboard.generalPasteboard();
			//设置/获取文本内容:
			generalPasteboard.plusCallMethod({
				setValue: copy_content,
				forPasteboardType: "public.utf8-plain-text"
			});
			generalPasteboard.plusCallMethod({
				valueForPasteboardType: "public.utf8-plain-text"
			});
			if (callback != undefined && callback != 'undefined' && Object.prototype.toString.call(callback) ==
				'[object Function]') {
				callback(true);
			}
		} else {
			//安卓
			var context = plus.android.importClass("android.content.Context");
			var main = plus.android.runtimeMainActivity();
			var clip = main.getSystemService(context.CLIPBOARD_SERVICE);
			plus.android.invoke(clip, "setText", copy_content);
			if (callback != undefined && callback != 'undefined' && Object.prototype.toString.call(callback) ==
				'[object Function]') {
				callback(true);
			}
		}

	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
}

/**
 * 发出峰鸣声
 * @param num 次数
 */
function deviceBeep(num) {
	// H5 plus事件处理
	function plusReady() {
		plus.device.beep(num);
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}
}

/**
 * 设置振动效果
 * @param milliseconds 振动时间单位为毫秒
 */
function deviceVibrate(milliseconds) {
	var objec = Number(milliseconds);
	var objecString = "" + objec;
	//判断是否为数字
	if (objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object Number]' &&
		objecString != NaN && objecString != 'NaN') {

		milliseconds = objec; //最终的值
	} else {
		milliseconds = 500; //最终的值
	}
	milliseconds = milliseconds + "ms";
	// H5 plus事件处理
	function plusReady() {
		plus.device.vibrate(milliseconds);
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}
}

/**
 * 设置右上角图标信息数
 * @param {Object} number
 * @param {Object} options
 */
function setBadgeNumber(number, title, content) {
	function plusReady() {
		var options = {};
		console.log('number = ' + number);
		plus.runtime.setBadgeNumber(number, {
			title: "提示",
			content: '提示提示提示提示'
		});
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}
}


/**
 * 后台运行
 */
function moveTaskToBack() {
	function plusReady() {
		try{
			var main = plus.android.runtimeMainActivity();  
			 main.moveTaskToBack(false); 
		}catch(e){
			//TODO handle the exception
		}
		  
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}
}

/**
 * 退出当前客户端
 */
function quit() {
	function plusReady() {
		plus.runtime.quit();
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}
}
/**
 * 预览图片
 */
function previewImage(objec, imgurl) {

	function plusReady() {
		var imgsArray = [];
		if (objec == undefined || objec == 'undefined' || Object.prototype.toString.call(objec) != '[object Array]') {
			objec = [];
		}
		imgsArray = objec;
		if (objec.length > 0) {
			var itemObjec = objec[0];
			var tUrl = "";
			if (itemObjec != undefined && itemObjec != 'undefined' && Object.prototype.toString.call(itemObjec) ==
				'[object Object]') {
				imgsArray = [];
				for (var i = 0; i < objec.length; i++) {
					tUrl = objec[i].url;
					if(tUrl != undefined && tUrl != 'undefined'&& tUrl != ''){
						tUrl = tUrl.replace(/\\/g,"/"); 
					}
					imgsArray.push(tUrl);
				}
			}
		}
		
		var current = 0;
		if(imgurl != undefined && imgurl != 'undefined'&& imgurl != ''){
			imgurl = imgurl.replace(/\\/g,"/"); 
		}
		for (var i = 0; i < imgsArray.length; i++) {
			if (imgsArray[i] == imgurl) {
				current = i;
				break;
			}
		}
		if (imgsArray.length > 0) {
			plus.nativeUI.previewImage(imgsArray, {
				//background: '#BC1818', //背景图片
				current: current, //索引值
			});
		}
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}
}
/**
 * 预览图片
 */
function previewImage1(imgsArray, current) {

	function plusReady() { 
		if (imgsArray.length > 0) {
			plus.nativeUI.previewImage(imgsArray, {
				//background: '#BC1818', //背景图片
				current: current, //索引值
			});
		}
	}
	if (window.plus) { 
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}
}
/**
 * 拨打电话
 */
function deviceDial(num) {
	function plusReady() {
		plus.device.dial(num, true)
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}
}
stopScrollBar(); //关闭页面滚动条

var scan = null;
/**
 * 二维码扫描
 * @param {Object} objec 回调函数 (扫描到的信息,码的类型,错误提示) 
 */
function QRCode(id, objec) {
	function plusReady() {
		colseScan(); //关闭
		startRecognize();
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener('plusready', plusReady, false);
	}
	//二维码信息

	function startRecognize() {
		scan = new plus.barcode.Barcode(id, [plus.barcode.QR, plus.barcode.EAN8, plus.barcode.EAN13], {
			frameColor: '#00FF00',
			scanbarColor: '#00FF00'
		});
		scan.onmarked = onmarked;
		scan.onerror = onerror;
		startScan();
	}

	/*
	 * 成功函数
	 */
	function onmarked(type, result) {
		var text = '未知: ';
		switch (type) {
			case plus.barcode.QR:
				text = 'QR: ';
				break;
			case plus.barcode.EAN13:
				text = 'EAN13: ';
				break;
			case plus.barcode.EAN8:
				text = 'EAN8: ';
				break;
		}
		chuli(result, text, '扫描成功！');
	}

	/**
	 * 失败函数
	 */
	function onerror() {
		chuli('', '', '扫描失败！');

	}

	function startScan() {
		scan.start();
	}

	function cancelScan() {
		scan.cancel();
	}

	function setFlash() {
		scan.setFlash();
	}

	function colseScan() {
		try {
			scan.close();
		} catch (e) {

		}

	}

	/**
	 * 总的处理函数
	 */
	function chuli(result, type) {
		if (result == '') {
			try {
				scan.cancel();
			} catch (e) {

			}
			try {
				scan.start();
			} catch (e) {

			}
		}
		if (objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object Function]') {
			objec(result, type);
		}
	}

}

/**
 * 从图片中扫码识别 
 * @param {Object} url：图片路径
 * @param {Object} objec 回调函数 (扫描到的信息,码的类型,错误提示) 
 */
function scanImg(url, objec) {
	plus.barcode.scan(url, function(type, result) {
		if (objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object Function]') {
			objec(result, type, '识别成功');
		}
	}, function(error) {
		if (objec != undefined && objec != 'undefined' && Object.prototype.toString.call(objec) == '[object Function]') {
			objec('', '', '识别失败，请正确选择二维码图片！');
		}
	});
}


/**
 * 获取支付通道
 */
function getChannels(callback) {
	function plusReady() {
		plus.payment.getChannels(function(channels) {
			if (callback != undefined && callback != 'undefined' && Object.prototype.toString.call(callback) ==
				'[object Function]') {
				callback(true, channels, '获取通道成功！');
			}
		}, function(e) {
			callback(false, [], "获取支付通道列表失败：" + e.message);
		});
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}
}


/**
 * 支付
 * type：0：微信支付 1：支付宝支付
 * data：微信支付{
 *			  "appid": "wx0411fa6a39d61297",
 *			  "noncestr": "lqVwlpytYU2WbfSU",
 *			  "package": "Sign=WXPay",
 *			  "partnerid": "1230636401",
 *			  "prepayid": "wx25171410002530cca401b82d0463858338",
 *			  "timestamp": 1553505250,
 *			  "sign": "AAC2704FF5A5A7A6138556E1DEAD8FE9"
 *			}
 * 支付宝支付：支付字符串
 * callback（true，提示）
 *	
 */
function payment(type, statement, callback) {
	function plusReady() {
		// 必须从业务服务器获取支付信息
		getChannels(function(isSuccess, data, msg) {
			var c = undefined;
			if (data.length > 0) {
				for (var i = 0; i < data.length; i++) {
					if ((data[i].id == 'alipay' && type == '1') || (data[i].id == 'wxpay' && type == '0')) {
						c = data[i];
					}
				}
				if (c != undefined && c != 'undefined') {
					plus.payment.request(c, statement, function() {
						callback(true, "支付操作成功！");
					}, function(e) {
						callback(false, "支付失败：" + e.message);
					});
				} else {
					callback(false, '支付失败，类型不支持！');
				}
			} else {
				callback(false, msg);
			}
		})

	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}
}

/**
 * 获取当前栈顶的对象
 */
function getTopWebview(callback) {
	function plusReady() {
		// 获取应用首页窗口对象
		var h = plus.webview.getTopWebview();
		if (Object.prototype.toString.call(callback) == '[object Function]') {
			if (h != undefined && h != 'undefined') {
				callback(h.getURL(), h.id);
			} else {
				callback("", "");
			}
		}
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}
}


function downOpenFile(url,isOpen,callback) {
	function plusReady() {
		url = url + "" ;
		url = url.replace(/\\/g,"/"); 
		if(url != '' &&  url != undefined  &&  url != 'undefined'){
			if(isOpen){
			  plus.nativeUI.showWaiting('正在为您打开文件...');
			}else{
			  plus.nativeUI.showWaiting('正在为您下载文件...');	
			}
			var dtask = plus.downloader.createDownload(url, {timeout:10,retry:0}, function(d, status) { //创建一个下载任务，可以在网上搜索这个方法了解
				if (status == 200) { 
					var newurl = plus.io.convertLocalFileSystemURL(d.filename);
                    plus.nativeUI.closeWaiting();
                    setTimeout(function(){
                    	plus.nativeUI.closeWaiting();
                    },100);
					if(isOpen){
						plus.runtime.openFile(d.filename, {}, function(e) { //调用第三方应用打开文件
							var message = e.message;
							if(message == 'not found 3th activity'){
								callback('打开失败，原因：未安装相应的三方软件！','');
							}else{
								callback('打开失败，原因：'+message,'');
							}
						});
					}else{
						callback('下载文件成功！',d.filename);
					}
				} else {
					plus.nativeUI.closeWaiting();
					setTimeout(function(){
						plus.nativeUI.closeWaiting();
					},100);
					if(Object.prototype.toString.call(callback) == '[object Function]'){
						if(isOpen){
							callback('打开失败，状态值：'+ status,'');
						}else{
							callback('下载失败，状态值：'+ status,'');
						}
					}
				}
			});
			dtask.start();
		}else{
			if(Object.prototype.toString.call(callback) == '[object Function]'){
				callback('文件地址不正确...','');
			}
		}
		
	}
	if (window.plus) {
		plusReady();
	} else {
		document.addEventListener("plusready", plusReady, false);
	}

}


/**
 * 提示对话框
 * @param {Object} str 提示内容
 */
function Msg2(str) {
	if(str == undefined || str == 'undefined' || str == '') {
		return;
	}

	mui.toast(str,{ duration:'long', type:'div' }) 
}
